precision mediump float;
varying vec2 vTexcoord0;
uniform sampler2D s_texture0;
uniform sampler2D s_texture1;

uniform vec2 poisson[12];

float hash(float n)
{
    return fract(sin(n)*43758.5453);
}

vec4 sample(vec2 s)
{
	// some shitty ssao
	vec4 blurred = texture2D(s_texture0, s + 1.5/256.0); 
	vec4 focused = texture2D(s_texture1, s);
	float depth_diff = clamp(- (blurred.w - focused.w), 0.0, 1.0);
	depth_diff = clamp(depth_diff * 4.0, 0.0, 1.1);
	if (focused.w > 0.98)
		depth_diff = -2.0;
	return clamp(focused - depth_diff, 0.0, 1.0); 
}

float occlusion(vec2 s, float off)
{
	// some shitty ssao
	vec4 blurred = texture2D(s_texture0, s + off); 
	vec4 focused = texture2D(s_texture1, s);
	float depth_diff = clamp(- (blurred.w - focused.w), 0.0, 1.0);
	depth_diff = clamp(depth_diff * 1.0, 0.0, 1.1);
	if (focused.w > 0.98)
		depth_diff = 0.0;
	return depth_diff;
}

void main() {

	float depth = texture2D(s_texture1, vTexcoord0).w;
	//depth = clamp(depth * 4.0, 0.0, 1.0);
	//vec4 focused = texture2D(s_texture1, vTexcoord0);

	int i;
	vec4 sum = vec4(0);
	

	float n = vTexcoord0.x * 113.0 + vTexcoord0.y * 57.0;
	//float n = fract(dot(vTexcoord0.xy,vec2(18428.4, 23614.3))) * 3.14;
	n = hash(n);

	// 2.0 and 10.0 are scales for perpixel blur (maxsize)
	// factor in scale (it is uniform) for lowres image
	vec2 rotx = vec2(cos(n), -sin(n)) * depth * (3.0 / 128.0);
	vec2 roty = vec2(sin(n),  cos(n)) * depth * (3.0 / 128.0);

	// TODO: move this to uniform...
	vec2 scaleHi = 1.0 / vec2(960.0, 540.0) * 10.0 / (3.0 / 128.0);

	for(i=0; i<12; i+=2)
	{
		// sample only values with larger depth
	
		vec2 rotated;
		rotated.x = dot(poisson[i].xy, rotx);
		rotated.y = dot(poisson[i].xy, roty);
				
		vec2 offHi = rotated * scaleHi;
		vec2 offLo = rotated * 0.8;		// tune this one to eliminate halo
		
		//vec4 dHi = sample(vTexcoord0 + offHi);//texture2D(s_texture1, vTexcoord0 + offHi);
		vec4 dHi = texture2D(s_texture1, vTexcoord0 + offHi);
		vec4 dLo = texture2D(s_texture0, vTexcoord0 + offLo);
		vec4 d = dLo * depth + dHi * (1.0 - depth);//mix(dHi, dLo, depth);


		float diff = d.w > depth ? 1.0 : d.w;

		sum.xyz += d.xyz * diff;
		sum.w += diff;
	}

	sum = sum / (sum.w + 0.1);		// will make it slightly darker but eliminate div by 0

	vec4 color = sum;//blurred + (focused - blurred) * (1.0 - depth);
	gl_FragColor = sum;//occlusion(vTexcoord0, 1.5/256.0) - occlusion(vTexcoord, 5.5/256.0) * (1.0 - depth) + 0.1;
}
